#! /usr/bin/env python
# coding: utf-8　
'''
Created on 2012/01/02

@author: YukiF

おお　ゆうしゃよ　なんときたない　こーど　ぢゃ
いふぶん　かさねすぎ　ぢゃろ
'''
import pygame, random
from pygame.locals import *
import s_title, data
#-----------------------------------------------------------------------------
class s_result(object):
    def __init__(self):
        #---------------------------------------------------------------------
        # 画像ロード
        self.info   = pygame.image.load("./img/hyoji.png")
        self.star   = pygame.image.load("./img/hosi.png")
        self.effect = pygame.image.load("./img/myef.png")
        #音声ロード
        self.pico   = pygame.mixer.Sound("./dat/pico.wav")
        
        self.st_last = Number(self.info, data.star_num_now)
        self.st_max = Number(self.info, data.star_num_max)
        self.st_sum = Number(self.info, data.star_num_sum)
        
        #　スコア計算
        self.tensu = (data.star_num_now*10)\
         + (data.star_num_max-data.star_num_now)*3 + data.star_num_sum
        
        self.score = Number(self.info, self.tensu)
        
        self.f_cnt = 0  #フレーム数計測
        self.go_tiok = False
        
        self.star_list=[]
        self.star_rest=sum(data.star_num_type[0:7])
        

    def draw(self):
        #　星は昇る--------------------------------------------------------------
        # 作成
        if self.star_rest > 0:
            if (self.f_cnt%3 == 0):
                if random.randint(0,2)==0:
                    self.star_list.append(star(self.star))
                    self.star_rest -= 1
        

        
        # 描画
        for i in self.star_list:
            i.draw()
            i.move()
        
        
        # 削除
        for i in range(len(self.star_list)-1,-1,-1):
            if self.star_list[i].die:
                del self.star_list[i]
                
        
        #-汚い汚いスコア表示-------------------------------------------------------
        if self.f_cnt > 30:
            data.screen.blit(self.info, [66,32],[288, 0, 32, 32])
            if self.st_last.draw([126,32]):
                data.screen.blit(self.info,
                                 [self.st_last.width()+132,32],
                                 [320, 0, 32, 32])
                
                data.screen.blit(self.info, [46,72],[640, 0, 64, 32])
                
                if self.st_max.draw([126,72]):
                    data.screen.blit(self.info,
                                     [self.st_max.width()+132,72],
                                     [320, 0, 32, 32])
                    
                    data.screen.blit(self.info, [46,112],[704, 0, 64, 32])
                    
                    if self.st_sum.draw([126,112]):
                        data.screen.blit(self.info,
                                         [self.st_sum.width()+132,112],
                                         [320, 0, 32, 32])
                        
                        data.screen.blit(self.info, [46,152],[352, 0, 64, 32])
                        
                        if self.score.draw([126,152]):
                            data.screen.blit(self.info,
                                             [self.score.width()+132,152],
                                             [416, 0, 32, 32])
                            
                            if ( int(str(self.f_cnt)[len(str(self.f_cnt))-1])>=4 ):
                                data.screen.blit (self.info,[46,260],
                                                  [448,0,192,32])
                                self.go_tiok = True
        
        if self.go_tiok:
            if data.mouse_state.pushL_Now():
                self.pico.play()
                pygame.time.wait(500)
                data.scene_next = s_title.s_title ()
                data.scene_change = True
                self.text()
                
        
        self.f_cnt+=1
        pass
    
    def text(self):
        f = open("score.txt","w")
        
        string = u"最後に星を持っていた数："
        string+=str(data.star_num_now)
        string+=u"こ\n"
        string+= u"一番たくさん持っていた時："
        string+=str(data.star_num_max)
        string+=u"こ\n"
        string+=u"あつまた星の合計数："
        string+=str(data.star_num_sum)
        string+=u"個\nScore："
        string+=str(self.tensu)
        string+=u"てん\n\n"
        if random.randint(0,100)==0:
            if random.randint(0,1)==0:
                string+=u"墜落した魔女は死にました\n"
            else:
                string+=u"墜落した魔女は以外にもぴんぴんしています！\n"
        else:
            string+=u"墜落した魔女は"
            if random.randint(0,1)==0:
                string+=str(random.randint(1,5))
                string+=u"ねんと"
                string+=str(random.randint(0,11))
                string+=u"ヶ月の重症をおいました\n"
            else:
                string+=str(random.randint(1,11))
                string+=u"ヶ月の重症をおいました\n"
            
            if data.star_num_now > 1500:
                string+=u"が、最新のテクノロジーで回復しました。やったね！\n"
            else:
                tmp = random.randint(0,4)
                if tmp==0:
                    string+=u"医療費で右往左往です。\n"
                elif tmp==1:
                    string+=u"人生順風満帆とはいいがたい\n"
                elif tmp==2:
                    string+=u"そんなこともあるさ\n"
                elif tmp==3:
                    string+=u"よるがたせいかつはやめよう！\n"
                else:
                    string+=u"でもお医者さんはちょういけめんでした！らっきー\n"
        f.write(string.encode('utf8','ignore'))
        f.close()

class Number(object):
    def __init__(self, image, num):
        self.cnt = 0
        self.n_cnt = 0
        self.num = num
        self.mojisuu =  len(str(self.num))
        self.img = image
    def width(self):
        return self.mojisuu*24
    
    def draw(self, pos):
        if self.cnt==3:
            self.cnt =0
            if self.n_cnt != self.mojisuu:
                self.n_cnt+=1
        else:
            self.cnt+=1
        
        for i in range(self.n_cnt):
            data.screen.blit(self.img, [pos[0]+i*24, pos[1]],
                             [int(str(self.num)[i])*24, 0, 24, 32])
        
        if self.mojisuu == self.n_cnt:
            return True
        else:
            return False

class star(object):
    def __init__(self, image):
        self.type = -1
        self.die = False
        self.img = image
        self.frame_cnt = 0
        self.rect = pygame.Rect(random.randint(300,736),
                                data.ws[1],32,32)
        self.speed = random.randint(5,10)
        self.anim_cnt = 0
        
        while True:
            if sum(data.star_num_type[0:7]) == 0:
                    self.die = True
                    break
            self.type = random.randint(0,6)
            if data.star_num_type[self.type]>0:
                data.star_num_type[self.type]-=1
                break
        

    def draw(self):
        if self.die:
            return
        data.screen.blit (self.img,self.rect,
                          [self.anim_cnt*32, self.type*32, 32, 32])

    def move (self):
        if self.die:
            return
        self.rect.top -= self.speed
        
        #　アニメーション処理
        if self.frame_cnt == 4:
            self.anim_cnt += 1
            self.frame_cnt = 0
        if self.anim_cnt > 3:
            self.anim_cnt = 0
        self.frame_cnt += 1
        
        #　見切れたらdieフラグをオン
        if self.rect.top < 0:
            self.die = True
            return