#! /usr/bin/env python
# coding: utf-8
'''
Created on 2011/12/31

@author: YukiF
'''
import math
#-----------------------------------------------------------------------------
# ウィンドウサイズ
ws = [800, 320] ;

# ウィンドウ タイトル
wt = "冬の夜空に"

# Display Surface
screen = None

# これがTrueになると終了する
game_end = False

# 色データ
COLOR = {"BLACK":[0,0,0], "WHITE":[255,255,255]}

# ゲームシーン
scene_change = False    # Trueのとき、シーンを切り替える
scene_next = None       #　ここに次のシーンを入れておく

# マウスの状態
mouse_state = None

# 月の動き
moon_move_x = []
moon_move_y = []
_moon_reso = 720*50
for cnt in range(_moon_reso/2,_moon_reso):
    moon_move_x.append(int(math.cos(
                        math.pi*2*(cnt)/_moon_reso)*600+(ws[0]/2))) #横
    moon_move_y.append(int(math.sin(
                        math.pi*2*(cnt)/_moon_reso)*360+ws[1]+180)) #縦
moon_move_x.reverse()
moon_move_y.reverse()

#-----------------------------------------------------------------------------
# スコア、ステータス関係
# 星の数
star_num_now    = 0    # 現在所持数
star_num_max    = 0    # 最大所持数
star_num_sum    = 0    # 合計所持数
star_num_type   = []   # 種類ごとに取得した数
shoot_star_num  = 0    # 流れ星を捕まえた数
# ゲージ
fly_power       = 0
# FPSカウント（難易度調整で使うかも？）
fps_cnt = 0

def reset_status():
    global star_num_now,star_num_max,star_num_sum
    global star_num_type,shoot_star_num, fly_power, fps_cnt
    global FLY_POW_MAX
    star_num_now    = 0
    star_num_max    = 0
    star_num_sum    = 0
    star_num_type   = [0,0,0,0,0,0,0,0]
    shoot_star_num  = 0
    fly_power       = FLY_POW_MAX

    
#-----------------------------------------------------------------------------
# バランス調整用の定数をここにつくっておきます
JUMP_COST = 25          #　上昇するために消費するコスト
BASIC_COST= 3           # BASIC_COSTフレームあたりゲージを1ポイント消費する
CURE_COST = 80           # CURE_COST/100の星を消費してゲージを最大まで回復する
CURE_COST_BORDER =100   # 回復に必要な最低量
FLY_POW_MAX = 200   # ゲージの最大量

STAR_EFFECT = {     #　星を取ったときの効果
               0:(1, 30, 0),    # 星+1、ゲージ40回復、特殊効果なし
               1:(1, 25, 0),
               2:(1, 20, 0),
               3:(2, 10, 0),
               4:(2, 6, 0),
               5:(3, 3, 0),
               6:(50,50, 1),    # 特殊効果1番
               7:(0, 200,2)     # 特殊効果2番
               }

STAR_CNT_DELAY = 60    # 前回の星発生からSTAR_CNT以内には星は発生しない
STAR_CNT_BORN  = 120    # STAR_CNT後、STAR_CNT_BORNフレーム内に必ず星が発生する
SHOOT_STAR_CNT = 300    #　SHOOT_STAR_CNTフレームに一回
SHOOT_STAR_PRB = 12     # 1/SHOOT_STAR_PRBの確立で流れ星発生