#! /usr/bin/env python
# coding: utf-8
'''
Created on 2011/12/31

@author: YukiF
'''
#-----------------------------------------------------------------------------
import pygame
from pygame.locals import *
import data, util
import s_title, s_stage,s_result
#-----------------------------------------------------------------------------
class game(object):
    def __init__(self):
        #---------------------------------------------------------------------
        # システム初期化設定
        pygame.init()
        data.screen = pygame.display.set_mode(data.ws)
        pygame.display.set_caption(data.wt)
        self.fpsTimer = pygame.time.Clock()
        data.mouse_state = util.mouseState()
        #---------------------------------------------------------------------
        # シーン読込
        self.scene = s_title.s_title()
        
    def mainloop(self):
        while data.game_end == False:
            self.event()
            
            data.screen.fill(data.COLOR["WHITE"])
            self.scene.draw()
            
            if (data.scene_change):
                self.scene = data.scene_next
                data.scene_change = False
            
            self.fpsTimer.tick (30) # FPS 30
            pygame.display.flip()
            
        pygame.quit()
        
    def event(self):
        for e in pygame.event.get():
            if (e.type == pygame.QUIT or util.keyRel(e,K_ESCAPE)):
                data.game_end = True
        data.mouse_state.getState()